' Oster-Contest, LeoBot1 (mit Tiny13)
'-------------------------------------------------------------------------------
' pb0=servo, pb1=servo, pb2=T1, pb3=T2, pb4=duoLED rot/weiss
'-------------------------------------------------------------------------------
$regfile = "attiny13.dat"
$prog &HFF , &H7A , &HFF , &H00
$crystal = 9600000
$hwstack = 8
$swstack = 16
$framesize = 24

Config Timer0 = Pwm , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up , Prescale = 256
' PWM-Frequenz 9600000Hz / 256 / 510 = 74Hz entspricht nicht genau 50Hz, geht aber

Ddrb = &B10011                                         'pwma, pwmb, t2, t3, LED
Portb = &B01100                                        'pullup

Dim Tasten As Byte
Const Warte1 = 2                                       '30 Drehung
Const Warte2 = 6                                       '90 Drehung
Const Stopab = 24                                      '1,5ms
Const Avor = 22                                        '1,6ms
Const Aruck = 26                                       '1,4ms
Const Bvor = Aruck                                     'invers
Const Bruck = Avor                                     'berkreuz

Do                                                     'Hauptprogramm

State0:
   Portb.4 = 1                                         'rot
   Pwm0a = Stopab                                      'A-stop
   Pwm0b = Stopab                                      'B-stop
   Tasten = Pinb                                       '0=beide, 4, 8, 12=keine
   Tasten = Tasten And 12
   If Tasten <> 12 Then Goto State0

State1:                                                'geradeaus
   Portb.4 = 0                                         'weiss
   Pwm0a = Avor                                        'A-vor
   Pwm0b = Bvor                                        'B-vor
   Tasten = Pinb                                       '0=beide, 4, 8, 12=keine
   Tasten = Tasten And 12
   If Tasten = 12 Then Goto State1

State5:                                                'zurck setzen
   Portb.4 = 1                                         'rot
   Pwm0a = Aruck                                       'A-rck
   Pwm0b = Bruck                                       'B-rck
   Wait Warte1

State4:                                                'frontal Hindernis
   If Tasten = 0 Then
      Pwm0a = Aruck                                    'A-rck
      Pwm0b = Bvor                                     'B-vor
      Wait Warte2 : End If

State2:                                                'Hindernis links
   If Tasten = 4 Then
      Pwm0a = Stopab                                   'A-stop
      Wait Warte1 : End If

State3:                                                'Hindernis rechts
   If Tasten = 8 Then
      Pwm0b = Stopab                                   'B-stop
      Wait Warte1 : End If
Loop
' End Program